#!/bin/bash

# Script de simplification de DL youtube

# commande zenity
ZENITY="/usr/bin/zenity --title YouTube "
# répertoire cible
DL_DIR="$HOME/Téléchargements/youtube"
# commande download
YOUTUBE_DL_CMD="/usr/bin/youtube-dl  -o \"$DL_DIR/%(stitle)s.%(ext)s\" --prefer-free-formats "

# Creation répertoire sible si nécessaire
mkdir -p $DL_DIR
if [ ! $? -eq 0 ] ; then
	echo "Impossible de créer $DL_DIR" >&2
	DL_DIR=$HOME
fi
 
# boite dialogue demande URL
VIDEO_URL=$($ZENITY --entry --text "Adresse de la vidéo" --width=600)
echo $VIDEO_URL

if [ -z $VIDEO_URL ] ; then 
	# pas d'URL	
	$ZENITY --error --text "Aucune vidéo à télécharger"
else
	# nom du fichier créé
	FILENAME=$($YOUTUBE_DL_CMD --get-filename "$VIDEO_URL")
	if [ $? -eq 0 ] ; then
		$ZENITY --info --text "Téléchargement en cours" &
	else
		$ZENITY --error --text "Erreur de téléchargement"
		exit 1
	fi
	echo "$YOUTUBE_DL_CMD \"$VIDEO_URL\""
	$YOUTUBE_DL_CMD "$VIDEO_URL"
	#youtube-dl  -o "$DL_DIR/%(stitle)s.%(ext)s" --prefer-free-formats "$VIDEO_URL"
	if [ $? -eq 0 ] ; then
		echo "Ouverture: $FILENAME"
		/usr/bin/nautilus "$FILENAME"
	else
		$ZENITY --error --text "Erreur de téléchargement"
	fi
fi

